function [RES]=Classic_CASEB_Uniform_SingleLoop(NAFEMS_Data,Sizesample)
% clc
% close
% clear variables

%% Solve The NAFEMS CHALLENGE PROBLEM CASE B: 9 Interval have been given which comes from 3 sources, 3 intervals for each parameter of interest (R,L,C)
% ASSUMING UNIFORM DISTRIBUTION (Laplace's Principia of indifference)
% And Compute Reliability w.r.t. 3 requirements
%1) Vc(10ms)>0.9
%2) Vc(t=tr)>0.9 and tr<8ms
%3) Z>=1
%% Single Loop MC CASE-B
% Compute Reliability of the system considering the three interval sources separatelly
% interval asignement
% a(1)=40;b(1)=1000;c(1)=1;d(1)=10;e(1)=1;f(1)=10; % Source 1
% a(2)=600;b(2)=1200;c(2)=10;d(2)=100;e(2)=1;f(2)=10; % Source 2
% a(3)=10;b(3)=1500;c(3)=4;d(3)=8;e(3)=0.5;f(3)=4; % Soruce 3
% e=e*10^-6; f=f*10^-6;  c=c*10^-3;  d=d*10^-3; % Right Unit of Mesure (milli and micron)

a=NAFEMS_Data.CASEAB_RminS ;b=NAFEMS_Data.CASEAB_RmaxS;
c=NAFEMS_Data.CASEAB_LminS ;d=NAFEMS_Data.CASEAB_LmaxS;
e=NAFEMS_Data.CASEAB_CminS ;f=NAFEMS_Data.CASEAB_CmaxS; 

%Sizesample=5*10^5; % samples number
%% MONTE CARLO SAMPLING

for i=1:3
    A=a(i);B=b(i);C=c(i);D=d(i);E=e(i);F=f(i); % SELECT INTERVAL INFORMATION PROVIDED BY SOURCE i
    R = A + rand(Sizesample,1).*(B-A);
    L = C + rand(Sizesample,1).*(D-C);
    C = E + rand(Sizesample,1).*(F-E);
    Zeta=0.5*R.*((C./L).^0.5);
    % eliminate underdumped samples
    R(Zeta<1)=[];
    L(Zeta<1)=[];
    C(Zeta<1)=[];
    %%  System Solver
    Vc08 = my_fun_Vc08(R,L,C);
    Vc10 = my_fun_Vc10(R,L,C);
    %Compute Failure Probability
    PVc10 =sum(Vc10<=0.9)/(Sizesample-sum(Zeta<1));
    PVctr =sum(Vc08<=0.9)/(Sizesample-sum(Zeta<1));
    Pz =sum(Zeta<1)/Sizesample;
    %Compute Coefficent of Variation
    
    COVZ=std(Zeta<1)/mean(Zeta<1);
    %% SAVE RESULTS
    RES.Vc10{i}=Vc10;
    RES.Vc08{i} = Vc08;
    RES.Z{i} = Zeta;
    RES.Pz{i}=Pz;
    RES.PVc10{i} = PVc10;
    RES.PVctr{i} = PVctr;
   %% PLOT CDFs
%      figure(1)
%     %colour for the plots
%     clr =[1   0   0
%         0.3  1   0.3
%         0   0   1];
%     %Linesyle
%     Style={'--';'-';':'};
%     Source={'Source 1','Source 2','Source 3'};
% %     %% PLOTS
%     %  subplot(3,2,1)
%     figure(1)
%     hold on
%     h(i) = cdfplot(Vc10);
%     xlabel('Vc(10ms)');
%     ylabel('F(Vc)');
%     set(h(i),'Color',clr(i,:),'linewidth',2)
%     set(h(i),'LineStyle',Style{i})
%     legend(Source{1},Source{2},Source{3},'Location','northwest')
%     set(gca,'fontsize',18)
%     
%     %   subplot(3,2,3)
%     figure(2)
%     hold on
%     h(i) = cdfplot(Vc08);
%     xlabel('Vc(8ms)');
%     ylabel('F(Vc)');
%     set(h(i),'Color',clr(i,:),'linewidth',2)
%     set(h(i),'LineStyle',Style{i})
%     legend(Source{1},Source{2},Source{3},'Location','northwest')
%     set(gca,'fontsize',18)
%     %    subplot(3,2,5)
%     figure(3)
%     hold on
%     h(i) = cdfplot(Zeta);
%     xlabel('Z');
%     ylabel('F(Z)');
%     set(h(i),'Color',clr(i,:),'linewidth',2)
%     set(h(i),'LineStyle',Style{i})
%     legend(Source{1},Source{2},Source{3},'Location','southeast')
%     set(gca,'fontsize',18)
end