function [RES]=Classic_CASEC_Kerneldensity(Dat,Sizesample)
% clc
% clear variables
% close
%% Solve The NAFEMS CHALLENGE PROBLEM CASE C: 10 sampled points for each parameter of interest (R,L,C)
% It has been used the Kernel Density Estimation of the 10 samples population
% And Compute Reliability w.r.t. 3 requirements
%1) Vc(10ms)>0.9
%2) Vc(t=tr)>0.9 and tr<8ms
%3) Z>=1
% Rs=[861,87,430,798,219,152,64,361,224,614]; % 10 samples for R
% Ls=[4.1,8.8,4.0,7.6,0.7,3.9,7.1,5.9,8.2,5.1];% 10 samples for L
% Ls=Ls*10^-3;
% Cs=[9,5.2,3.8,4.9,2.9,8.3,7.7,5.8,10,0.7];% 10 samples for C
% Cs=Cs*10^-6;

%Sizesample=10^4;

Rs=Dat.CASEC_Rs;Ls=Dat.CASEC_Ls;Cs=Dat.CASEC_Cs ;
% fit distribution fucntion on the given samples
%'width' --> computed as optimal with respect to normal kernels
pdfR =fitdist(Rs','Kernel','support','positive');
pdfL =fitdist(Ls','Kernel','support','positive');
pdfC =fitdist(Cs','Kernel','support','positive');
% RANDOMIZE C R L BASED ON THE PDFS
%C=Cs(i)*ones(Sizesample,1);
R=pdfR.random(Sizesample,1);
L=pdfL.random(Sizesample,1);
C=pdfC.random(Sizesample,1);
% C=Cs(J)*ones(Sizesample,1);
%COMPUTE Z
Zeta=0.5*R.*((C./L).^0.5);
% eliminate underdumped samples
R(Zeta<1)=[];
L(Zeta<1)=[];
C(Zeta<1)=[];
%%  System Solver
Vc08 = my_fun_Vc08(R,L,C);
Vc10 = my_fun_Vc10(R,L,C);
%Compute Failure Probability
PVc10 =sum(Vc10<=0.9)/(Sizesample-sum(Zeta<1));
PVctr =sum(Vc08<=0.9)/(Sizesample-sum(Zeta<1));
Pz =sum(Zeta<1)/Sizesample;
%% SAVE RESULTS
RES.Vc10=Vc10;
RES.Vc08=Vc08;
RES.Z=Zeta;
RES.Pz=Pz;
RES.PVc10=PVc10;
RES.PVctr=PVctr;
%% PLOT CDFs
% figure (1)
% hold on
% ecdf(RES.Vc08)
% xlabel('Vc(t=8ms)','FontSize',16);
% ylabel('ECDF(Vc)','FontSize',16);
% %title('Kernel Density approach','FontSize',16);
% fig=gcf;
% set(findall(fig,'-property','FontSize'),'FontSize',16)
% legend('Kernel')
% figure (2)
% hold on
% ecdf(RES.Vc10)
% xlabel('Vc(t=10ms)','FontSize',16);
% ylabel('ECDF(Vc)','FontSize',16);
% %title('Kernel Density approach','FontSize',16);
% fig=gcf;
% set(findall(fig,'-property','FontSize'),'FontSize',16)
% legend('Kernel')
% figure (3)
% hold on
% ecdf(RES.Z)
% xlabel('Z','FontSize',16);
% ylabel('ECDF(Z)','FontSize',12);
% %title('Kernel Density approach','FontSize',16);
% fig=gcf;
% set(findall(fig,'-property','FontSize'),'FontSize',16)
% legend('Kernel')
%end
end