function [RES]=Classic_CASEC_Uniform(Dat,Sizesample)
% clc
% clear variables
% close
%% Solve The NAFEMS CHALLENGE PROBLEM CASE C: 10 sampled points for each parameter of interest (R,L,C)
% It has been used the Uniform Distribution haveing bounds equal to min-max of the 10 samples population
% And Compute Reliability w.r.t. 3 requirements
%1) Vc(10ms)>0.9
%2) Vc(t=tr)>0.9 and tr<8ms
%3) Z>=1

%% DATA
% Rs=[861,87,430,798,219,152,64,361,224,614];
% Ls=[4.1,8.8,4.0,7.6,0.7,3.9,7.1,5.9,8.2,5.1];
% Cs=[9,5.2,3.8,4.9,2.9,8.3,7.7,5.8,10,0.7];
% Cs=Cs*10^-6; Ls=Ls*10^-3;
Rs=Dat.CASEC_Rs;Ls=Dat.CASEC_Ls;Cs=Dat.CASEC_Cs ;
%Sizesample=10^4; % MC samples

%% considered interval (min max of the sample)
A=min(Rs);B=max(Rs);
C=min(Ls);D=max(Ls);
E=min(Cs);F=max(Cs);
%Random Sampling
X=rand(Sizesample,3);
R = A + X(:,1).*(B-A); %UNIFORM BETWEEN MIN MAX of THE SAMPLES
L = C + X(:,2).*(D-C); %UNIFORM BETWEEN MIN MAX of THE SAMPLES
C = E + X(:,3).*(F-E); %UNIFORM BETWEEN MIN MAX of THE SAMPLES
%COMPUTE Z
Zeta=0.5*R.*((C./L).^0.5);

% eliminate underdumped samples requirement 3
R(Zeta<1)=[];
L(Zeta<1)=[];
C(Zeta<1)=[];


%%  System Solver
Vc08 = my_fun_Vc08(R,L,C);
Vc10 = my_fun_Vc10(R,L,C);
%% SAVE RESULTS
RES.Vc10=Vc10;
RES.Vc08=Vc08;
RES.Z=Zeta;
% probability of fial the requirements
RES.PVc10 =sum(Vc10<=0.9)/length(R);
RES.Ptr =sum(Vc08<=0.9)/length(R);
RES.Pz=sum(Zeta<1)/Sizesample;

%% PLOT RESULTS
% figure (1)
% hold on
% ecdf(RES.Vc08)
% xlabel('Vc(t=8ms)','FontSize',16);
% ylabel('ECDF(Vc(8ms))','FontSize',16);
% %title('Kernel Density approach','FontSize',16);
% set(gca,'fontsize',16)
% legend('Uniform')
% hold off
% 
% figure (2)
% hold on
% ecdf(RES.Vc10)
% xlabel('Vc(t=10ms)','FontSize',16);
% ylabel('ECDF(Vc(10ms))','FontSize',16);
% %title('Kernel Density approach','FontSize',16);
% set(gca,'fontsize',16)
% legend('Uniform')
% hold off
% 
% figure (3)
% hold on
% ecdf(RES.Z)
% xlabel('Z','FontSize',16);
% ylabel('ECDF(Z)','FontSize',16);
% %title('Kernel Density approach','FontSize',16);
% set(gca,'fontsize',16)
% legend('Uniform')
% hold off
end
