function [RES]=DS_CASEB(NAFEMS_Data,m1,m2,Sizesample)
% clc
% close
% clear variables
%% Solve The NAFEMS CHALLENGE PROBLEM CASE B: 9 Interval have been given which comes from 3 sources, 3 intervals for each parameter of interest (R,L,C)
% ASSUMING UNIFORM DISTRIBUTION (Laplace's Principia of indifference)
% And Compute Reliability w.r.t. 3 requirements
%1) Vc(10ms)>0.9
%2) Vc(t=tr)>0.9 and tr<8ms
%3) Z>=1
%% DATA
% Compute Reliability of the system considering the three interval sources separatelly
% interval asignement
% a(1)=40;b(1)=1000;c(1)=1;d(1)=10;e(1)=1;f(1)=10; % Source 1
% a(2)=600;b(2)=1200;c(2)=10;d(2)=100;e(2)=1;f(2)=10; % Source 2
% a(3)=10;b(3)=1500;c(3)=4;d(3)=8;e(3)=0.5;f(3)=4; % Soruce 3
% e=e*10^-6; f=f*10^-6;  c=c*10^-3;  d=d*10^-3; % Right Unit of Mesure (milli and micron)
%m1=1/3;m2=1/3;% BASIC PROBABILITY Assignment, assign probabilty masses  sources 1&2
a=NAFEMS_Data.CASEAB_RminS ;b=NAFEMS_Data.CASEAB_RmaxS;
c=NAFEMS_Data.CASEAB_LminS ;d=NAFEMS_Data.CASEAB_LmaxS;
e=NAFEMS_Data.CASEAB_CminS ;f=NAFEMS_Data.CASEAB_CmaxS; 

%Sizesample=10^4; % for min-max approximative search



%% ASSIGN MASSES
% mass assignement to the different sources of information
abR(1)=m1;cdL(1)=m1;efC(1)=m1;
abR(2)=m2;cdL(2)=m2;efC(2)=m2;
abR(3)=1-m1-m2; cdL(3)=1-m1-m2;efC(3)=1-m1-m2;

 
%% evaluate each RLC parameter cell (27 cells 3*3*3 intervals)
% preallocate memory
TOTALCELLS=length(a)*length(c)*length(e);
VC10MAX=zeros(1,TOTALCELLS);VC10MIN=zeros(1,TOTALCELLS);VC08MAX=zeros(1,TOTALCELLS); VC08MIN=zeros(1,TOTALCELLS); ZMAX=zeros(1,TOTALCELLS); ZMIN=zeros(1,TOTALCELLS); Mass=zeros(TOTALCELLS,1);
IDX=0;
for k=1:size(a,2)% for each R interval
    for s=1:size(c,2)% for each L interval
        for j=1:size(e,2)% for each C interval ( %set k=1;s=1;j=1; % to collapse to CASE A )
        
            IDX= IDX+1;
            %Compute Probability mass
            Mass(IDX)=abR(k)*cdL(s)*efC(j);
            % set the elements to create the focal cell
            A=a(k);B=b(k);C=c(s);D=d(s);E=e(j);F=f(j);
            % latin hypercube design to sample withing the cell
            X = lhsdesign(Sizesample,3);
            % Sample the parameter (here is for min-max search pourpouse)
            % alternative is to solve a minimization maximization
            % constrained problem with non linear constrain on Z
            R = A + X(:,1).*(B-A);
            L = C + X(:,2).*(D-C);
            C = E + X(:,3).*(F-E); 
            % compute damping factor
            Zeta=0.5*R.*((C./L).^0.5); 
            % eliminate underdumped samples
            R(Zeta<1)=[];
            L(Zeta<1)=[];
            C(Zeta<1)=[];
            % Zeta(Zeta<1)=[];
            %%  System Solver
            Vc08 = my_fun_Vc08(R,L,C);
            Vc10 = my_fun_Vc10(R,L,C);
            %% Find minimum and maximum (approximation trough sampling)
            VC10MIN(IDX)=min(Vc10);
            VC10MAX(IDX)=max(Vc10);
            VC08MIN(IDX)=min(Vc08);
            VC08MAX(IDX)=max(Vc08);
            ZMAX(IDX)= max(Zeta);
            ZMIN(IDX)= min(Zeta);
        end
    end
end
%% build DS strucutre
dsTR=dsstruct([VC08MIN',VC08MAX',Mass]);
dsVC=dsstruct([VC10MIN',VC10MAX',Mass]);
dsZ=dsstruct([ZMIN',ZMAX',Mass]);
%% Save Results
RES.dsTR=dsTR;
RES.dsVC=dsVC;
RES.dsZ=dsZ;
%% diferent mass functions
% down(:,1)=dsTR.ds(:,1);
% down(:,2)=dsTR.ds(:,3);
% down=sortrows(down,1);
% up(:,1)=dsTR.ds(:,2);
% up(:,2)=dsTR.ds(:,3);
% up=sortrows(up,1);
% for i=2:size(dsTR.ds,1)
%     down(i,2)=down(i-1,2)+down(i,2);
%     up(i,2)=up(i-1,2)+up(i,2);
% end
% [xa,xb]=stairs([down(1,1);down(:,1);up(size(up,1),1)],[0;down(:,2);1]);
% [xc,xd]=stairs([down(1,1);up(:,1)],[0;up(:,2)]);
% % %plot(xa,xb,'--k',xc,xd,'k','linewidth',1.5);
% %  subplot(3,2,4)
% hold on;
% plot(xa,xb,'--k','linewidth',1.5);
% plot(xc,xd,'-k','linewidth',1.5);
% % %xlabel('x','FontSize',12,'fontweight','bold');
% % %ylabel('p([0,x])','FontSize',12,'fontweight','bold');
% set(gca,'fontsize',18)
% xlim([down(1,1)-up(size(up,1),1)*0.02,up(size(up,1),1)*1.02]);
% % % xlim([0-100000*0.02,100000]);
% ylim([-0.0,1.02]);
% % %legend('Pl([0,x])','Bel([0,x])',4);
% legend('Pl','Bel',4);
% xlabel('VC(8ms)');
% ylabel('Comnulative plausibility/belif functions');
% % dscdf(dsTR)
% %      subplot(3,2,6)]
% figure(2)
% hold on
% % ecdf(ZMIN)
% % ecdf(ZMAX)
% down(:,1)=dsZ.ds(:,1);
% down(:,2)=dsZ.ds(:,3);
% down=sortrows(down,1);
% up(:,1)=dsZ.ds(:,2);
% up(:,2)=dsZ.ds(:,3);
% up=sortrows(up,1);
% for i=2:size(dsZ.ds,1)
%     down(i,2)=down(i-1,2)+down(i,2);
%     up(i,2)=up(i-1,2)+up(i,2);
% end
% [xa,xb]=stairs([down(1,1);down(:,1);up(size(up,1),1)],[0;down(:,2);1]);
% [xc,xd]=stairs([down(1,1);up(:,1)],[0;up(:,2)]);
% % %plot(xa,xb,'--k',xc,xd,'k','linewidth',1.5);
% hold on;
% plot(xa,xb,'--k','linewidth',1.5);
% plot(xc,xd,'-k','linewidth',1.5);
% % %xlabel('x','FontSize',12,'fontweight','bold');
% % %ylabel('p([0,x])','FontSize',12,'fontweight','bold');
% set(gca,'fontsize',18)
% xlim([down(1,1)-up(size(up,1),1)*0.02,up(size(up,1),1)*1.02]);
% % % xlim([0-100000*0.02,100000]);
% ylim([-0.0,1.02]);
% % %legend('Pl([0,x])','Bel([0,x])',4);
% legend('Pl','Bel',4);
% xlabel('Z');
% ylabel('Comnulative plausibility/belif functions');
% % subplot(3,2,2)
% figure(3)
% hold on
% % ecdf(VCMIN)
% % ecdf(VCMAX)
% down(:,1)=dsVC.ds(:,1);
% down(:,2)=dsVC.ds(:,3);
% down=sortrows(down,1);
% up(:,1)=dsVC.ds(:,2);
% up(:,2)=dsVC.ds(:,3);
% up=sortrows(up,1);
% for i=2:size(dsVC.ds,1)
%     down(i,2)=down(i-1,2)+down(i,2);
%     up(i,2)=up(i-1,2)+up(i,2);
% end
% [xa,xb]=stairs([down(1,1);down(:,1);up(size(up,1),1)],[0;down(:,2);1]);
% [xc,xd]=stairs([down(1,1);up(:,1)],[0;up(:,2)]);
% % %plot(xa,xb,'--k',xc,xd,'k','linewidth',1.5);
% plot(xa,xb,'--k','linewidth',1.5);
% plot(xc,xd,'-k','linewidth',1.5);
% % %xlabel('x','FontSize',12,'fontweight','bold');
% % %ylabel('p([0,x])','FontSize',12,'fontweight','bold');
% set(gca,'fontsize',18)
% xlim([down(1,1)-up(size(up,1),1)*0.02,up(size(up,1),1)*1.02]);
% % % xlim([0-100000*0.02,100000]);
% ylim([-0.0,1.02]);
% % %legend('Pl([0,x])','Bel([0,x])',4);
% legend('Pl','Bel',4);
% xlabel('Vc(10ms)');
% ylabel('Comnulative plausibility/belif functions');
end